/* PTViewer	-	Interactive Viewer for Panoramic Images
   Copyright (C) 2000 - Helmut Dersch  der@fh-furtwangen.de
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*------------------------------------------------------------*/

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;
import java.net.URLConnection;
import java.util.*;
import java.text.*;
import java.io.*;
import java.lang.reflect.*;

public class ptvjapp extends Frame{ /* implements  MRJAboutHandler, 
											   MRJOpenDocumentHandler,
											   MRJQuitHandler{ */
	
	static public void main(String args[]) {
   		System.runFinalizersOnExit(true);
   		String theFile = null;
		
		/*
    	if( MRJApplicationUtils.isMRJToolkitAvailable() ){
			MRJApplicationUtils.registerAboutHandler(this);
			MRJApplicationUtils.registerOpenDocumentHandler(this);
			MRJApplicationUtils.registerQuitHandler(this);
		}
		setPTViewerMenu();
		*/
   		
   		if( args.length == 0 ){ // Check for defaults html file
   			/*File f = new File( "default.html" );
			if( f.exists() ){
				theFile = "default.html";
			}else{
				try{
					Class c = Class.forName("ptviewer");
					InputStream is = c.getResourceAsStream( "default.html" );
					is.close();
 					theFile = "default.html";
 				}catch(Exception e){}
 			}*/
 			theFile = "default.html"; // this is preliminary
 		}else
 			theFile = args[0];
		if( theFile != null ){	
			new ptvjapp(theFile);
		}
	}

	public ptvjapp(String theFile){ 
		String s = null;
		int w = 320, h=200;
 		
		Applet applet = new ptviewer();
    		add ("Center", applet);
   		
		addWindowListener( new WindowAdapter() {
    			public void windowClosing ( WindowEvent event){
    				Applet a = (Applet) event.getWindow().getComponent(0);
            			a.stop();
              			a.destroy();
              			System.exit(0);
          		}
    		});

 		//applet.setStub (new ptstub(theFile, applet, this));
		applet.setStub (new ptstub(theFile, this));
 
 		// Set size
 
		s = applet.getParameter("width"); if( s != null ){
			System.out.println("width" + w); 
			w = Integer.parseInt(s); 
		}
		s = applet.getParameter("height");if( s != null ){ 
			System.out.println("height" + h); 
			h = Integer.parseInt(s);
		}	
 		resize(w,h);
		
		// Set title
 		if( (s = applet.getParameter("name")) != null )
 			setTitle( s );
		
    		setVisible(true);		
		
		// Resize if applet is smaller than frame
 		Dimension d = applet.getSize();
		if( d.width != w || d.height != h ){
			//System.out.println( d.width + " " + d.height );
			d.width = w + w - d.width;
			d.height = h + h - d.height;
			//System.out.println( d.width + " " + d.height );
			resize(d);
			applet.resize(w,h);
		}
			
 		
   		applet.init();
    	applet.start();

    	addComponentListener( new  ComponentAdapter() {
    		public void componentResized(ComponentEvent event){
    				Applet a = (Applet) ((Frame)event.getComponent()).getComponent(0);
     				a.stop();
     				a.start();
      		}
    	}); 
		
	
	} 
}
